#
#  common.tcl (for MT)
#
#  $Id: common.tcl,v 1.44.4.1 2004/03/18 15:37:46 source Exp $
#
#  Common Code
#
#  (C)Copyright 2002 OpenLink Software.
#  All Rights Reserved.
#
#  The copyright above and this notice must be preserved in all
#  copies of this source code.  The copyright above does not
#  evidence any actual or intended publication of this source code.
#
#  This is unpublished proprietary trade secret of OpenLink Software.
#  This source code may not be copied, disclosed, distributed, demonstrated
#  or licensed except as authorized by OpenLink Software.
#

proc productname {nametype} {
    global GlobalProductID
    if {[master GlobalProductID] == "MT"} {
	set shortname "Admin Assistant"
	set longname  "OpenLink Admin Assistant"
    } else {
	set shortname "OpenLink ODBC Administrator"
	set longname  "HTTP-based OpenLink ODBC Administrator"
    }
    switch $nametype {
	"short"		{return $shortname}
	"version" 	{return "v1.41"}
	"release"	{return "Release 5.1"}
	"copyright" 	{return "Copyright \&copy\; 2004 OpenLink Software"}
	default 	{return $longname}
    }
}

# Return true if this is a Virtuoso product
proc productvirt {} {
    return 0
}

proc TITLE {args} {
    TITLE1 $args
    TITLE2 ""
}

proc TITLE1 {titlestring} {
    html <html><head><title>[join $titlestring]</title>\n
}

proc TITLE2 {bodyarg} {
    html <meta name="author" content="OpenLink Software">\n
    html <meta http-equiv="Content-Type" content="text/html\; charset=UTF-8">\n
    html </head>\n<body bgcolor=#FFFFFF text=#000000 link=#0000FF vlink=#0000FF [join $bodyarg]>\n
}

proc HEAD {args} {
    html <center><h2>[join $args]</h2></center><hr>\n
}

proc SECTION {args} {
    html <h2><font color='#0000ff'>[join $args]</font></h2>\n
}

proc debug {s} {
    logmsg DEBUG $s
}

proc footer {} {
    html \n<p><hr><font size=2>\nThe [productname long] [productname version] - [productname copyright]\n</font></p>\n
}

proc menu_footer {} {
    html \n<p><hr><font size=1>\nThe [productname long] [productname version]<br>[productname copyright]\n</font></p>\n
}

proc menu_button {} {
    set prev [req header Referer]
    if {![string match "*/scripts/menu/*" [req header Referer]]} {
        set prev /scripts/menu
    }
    html <a href="/" target="_top">[productname short] Main Menu</a><br>\n
}

proc main_button {} {
    menu_button
    footer
}

# List sort with ignore case (lsort -dictionary)
proc lsort2 {lin} {
    if {[llength $lin] == 0} {
	return $lin
    }
    set i 0
    foreach a $lin {
	# add space so all items get enclosed by curly brace thus removes brace from sort
	lappend lupper [list [string toupper "$a "] $i]
	set i [expr $i +1]
    }
    set slupper [lsort $lupper]
    foreach ai $slupper {
	set i [lindex $ai 1]
	lappend lout [lindex $lin $i]
    }
    return $lout
}

proc dsnwizardtabs {isodbc thistab} {
    global GlobalProductID

    if {!$isodbc || [master GlobalProductID] == "MT"} {
	set is_mt 1
    } else {
	set is_mt 0
    }
    html {
    	<table border="0" cellpadding="0" cellspacing="0">
	<tr valign="bottom">
    }
    html {<td><a href="/scripts/}
    if {$isodbc} {
	html wods
    } else {
	html wds
    }
    html {"><img src="/images/ds0.gif" width="95" height="22" border="0">}
    if {$thistab==1} {
	html {<br clear="all"><img src="/images/s95.gif" width="95" height="3" border="0">}
    }
    html </a></td>\n

    if {$is_mt} {
	html {<td><a href="/scripts/}
	if {$isodbc} {
	    html wost
	} else {
	    html wst
	}
	html {"><img src="/images/st0.gif" width="95" height="22" border="0">}
	if {$thistab==2} {
	    html {<br clear="all"><img src="/images/s95.gif" width="95" height="3" border="0">}
	}
	html </a></td>\n

	html {<td><a href="/scripts/}
	if {$isodbc} {
	    html woco
	} else {
	    html wco
	}
	html {"><img src="/images/co0.gif" width="110" height="22" border="0">}
	if {$thistab==3} {
	    html {<br clear="all"><img src="/images/s110.gif" width="110" height="3" border="0">}
	}
	html </a></td>\n
    }
    html {<td><a href="/scripts/}
    if {$isodbc} {
	html {wod"><img src="/images/od0}
    } else {
	html {wud"><img src="/images/ud0}
    }
    html {.gif" width="50" height="22" border="0">}
    if {$thistab==4} {
	html {<br clear="all"><img src="/images/s50.gif" width="50" height="3" border="0">}
    }
    html </a></td>\n

    html {<td><a href="/scripts/}
    if {$isodbc} {
	html woab
    } else {
	html wuab
    }
    html {"><img src="/images/ab0.gif" width="50" height="22" border="0">}
    if {$thistab==5} {
	html {<br clear="all"><img src="/images/s50.gif" width="50" height="3" border="0">}
    }
    html {</a></td>
    </tr>
    <tr>
    <td>}
    if {$thistab!=1} {
	html <img src="/images/b95.gif" width="95" height="1">
    }
    html </td>\n
    if {$is_mt} {
	html <td>
	if {$thistab!=2} {
	    html <img src="/images/b95.gif" width="95" height="1">
	}
	html </td>\n<td>
	if {$thistab!=3} {
	    html <img src="/images/b110.gif" width="110" height="1">
	}
	html </td>\n
    }
    html <td>
    if {$thistab!=4} {
	html <img src="/images/b50.gif" width="50" height="1">
    }
    html </td>\n<td>
    if {$thistab!=5} {
	html <img src="/images/b50.gif" width="50" height="1">
    }
    html </td>\n</tr></table>\n
}

# Name= submit name or ""
# Width
# Label text
# onclick= or ""
proc wizardbutton2 {n w l o} {
    html {<input type=}
    if {$n==""} {
	html "\"button\""
    } else {
	html "\"submit\" name=\"$n\""
    }
    scan [navigator appVersion] "%d" nv
    if {[navigator appName] != "Netscape"} {
	html " value=\"$l\""
    } else {
	if {$nv == 4} {
	    html " value=\"[string trim $l]\" width=\"$w\""
	} else {
	    html " value=\"$l\""
	}
    }
    if {$o !=""} {
	html { onclick='}
	html $o\'
    }
    html >
}

# Name= submit name or ""
# Width
# Label text
# onclick= or ""
proc wizardbutton {n w l o} {
    html <tr><td>
    wizardbutton2 $n $w $l $o
    html </td></tr>\n
}


#
#  check if value is ON, (Y)ES, (T)RUE or 1
#
proc IsTrue {value} {
  set value [string toupper $value]
  if {$value == "ON" || $value == "YES" || $value == "Y" || $value == "TRUE" || $value == "T" || $value == "1"} {
    return 1
  }
  return 0
}
