#
#  navigator.tcl
#
#  $Id: navigator.tcl,v 1.1 2002/07/02 13:17:05 source Exp $
#
#  HTTP header routins to detail the browser
#
#  (C)Copyright 2002 OpenLink Software.
#  All Rights Reserved.
#
#  The copyright above and this notice must be preserved in all
#  copies of this source code.  The copyright above does not
#  evidence any actual or intended publication of this source code.
#
#  This is unpublished proprietary trade secret of OpenLink Software.
#  This source code may not be copied, disclosed, distributed, demonstrated
#  or licensed except as authorized by OpenLink Software.
#


#appName:Netscape
#appCodeName:Mozilla
#userAgent:Mozilla/4.7 [en-gb] (WinNT; I)
#appVersion:4.7 [en-gb] (WinNT; I)
#
#appName:Microsoft Internet Explorer
#appCodeName:Mozilla
#userAgent:Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)
#appVersion:4.0 (compatible; MSIE 6.0; Windows NT 5.0)
#
#appName:Microsoft Internet Explorer
#appCodeName:Mozilla
#userAgent:Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0; .NET CLR 1.0.3705)
#appVersion:4.0
#
#appName:Opera
#appCodeName:Mozilla
#userAgent:Opera/6.01 (Windows 2000; U)  [en]
#appVersion:6.01 (Windows 2000; U)
#
#appName:Netscape
#appCodeName:Mozilla
#userAgent:Mozilla/5.0 (Windows; U; Windows NT 5.0; en-GB; m18) Gecko/20010131 Netscape6/6.01
#appVersion:5.0 (Windows; en-GB)
#
#appName:Netscape
#appCodeName:Mozilla
#userAgent:Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:0.9.9) Gecko/20020311
#appVersion:5.0 (Windows; en-US)

#
# Return values normally available from the navigator object in javascript
# Param is: appName, appCodeName, userAgent, appVersion
#
proc navigator {param} {
    set ua [req header User-Agent]
    set ualist [split $ua "/ "]
    set agname [lindex $ualist 0]
    set ver [lindex $ualist 1]

    switch $param {
	userAgent { return $ua }
	appVersion { return $ver }
	appName {
	  if {$agname == "Opera"} { return $agname }
	  if {[string first MSIE $ua] > 0} { return "Microsoft Internet Explorer" }
	  if {[string first Netscape $ua] > 0} { return "Netscape" }
	  if {[string first Gecko $ua] > 0} { return "Netscape" }
	  if {$agname == "Mozilla"} { return "Netscape" }
	  return $agname
	}
	appCodeName {
	  if {$agname == "Opera"} { return Mozilla }
	  return $agname
	}
	default { return "" }
    }
}
